--[[ todo
- add bg circles with bgfat
- add other cat features
- impossible: scale whole cat
]]--

function love.load()

	lg = love.graphics
	la = love.audio

	love.window.setMode(1280,720)

	state = "start" -- can be start, game, end

	img = {
		start = lg.newImage("startscreen.png"),
		food  = lg.newImage("food.png"),
		end1 = lg.newImage("end1.png"),
		end2 = lg.newImage("end2.png"),
		catdetails = lg.newImage("catdetails.png"),
	}
	
	aud = {
		yay = la.newSource("yay.ogg"),
		bg = la.newSource("uke.ogg"),
		plop ={
			la.newSource("plop1.ogg"),
			la.newSource("plop2.ogg"),
			la.newSource("plop3.ogg"),
		},
		meow ={
			la.newSource("meow1.ogg"),
			la.newSource("meow2.ogg"),
			la.newSource("meow3.ogg"),
		},
		gameover = la.newSource("gameover.ogg"),
	}
	
	-- colors
	c = {
		blue  = {46,85,108},
		white = {255,255,255},
		black = {0,0,0},
		pink1 = {211,100,188},
		pink2 = {233,111,177},
		pink3 = {222,122,199},
	}
	
	aud.bg:setLooping(true)
	
	aud.bg:play()
	
	lg.setBackgroundColor(222,111,188)
	
	timer = 0
	fat = 1
	bgfat = 1 -- for bg
	lg.setFont(lg.newFont("Chewy.ttf",64))
	
	win = false
	
	food = {}
	
end

function throw()
	local x,y
	local rand = math.random(3)
	if rand == 1 then
		x,y = -64,math.random(-64,784)
	elseif rand == 2 then
		x,y = 1344,math.random(-64, 784)
	elseif rand == 3 then
		x,y = math.random(-64,1344),-64
	elseif rand == 4 then
		x,y = math.random(-64,1344),784
	end
  table.insert(food,{
    x = x,
    y = y,
	rot = math.random(360),
    del = false, --marker for deletion (ffs lua)
  })
end

function love.update(dt)

	if state == "game" then
		-- move food
		for i,u in ipairs(food) do
			-- move
			dv = {}
			nv = {}
			dv.x = 640 - u.x
			dv.y = 360 - u.y
			nv.x, nv.y = nvec(dv)
			u.x = u.x + nv.x*2
			u.y = u.y + nv.y*2
		end
		

		timer = timer + dt
		bgfat = bgfat + (timer*timer)/20000	
		
		-- throw new food
		if #food < math.floor(timer/4 * timer/4) then
			throw()
		end
		-- clean up lists
		for i = #food, 1, -1 do
			if food[i].del then
				table.remove(food,i)
			end
		end
		
		-- cat eats
		-- currently not ok
		for i,u in ipairs(food) do
			if dist(u,{x=640,y=360}) < 220 then
				u.del = true
				fat = fat + .05
				local rand = math.random(3)
				aud.meow[rand]:stop()
				aud.meow[rand]:play()
			end
		 end
		 -- time runs out or cat explodes asplodes
		 
		 if timer > 30 then
			endtime = math.floor(timer)
			timer = 0
			state = "end"
			win =true
			aud.bg:stop()
			aud.yay:play()
		 elseif fat >= 3 then
			endtime = math.floor(timer)
			timer = 0
			state = "end"
			aud.bg:stop()
			aud.gameover:play()
		 end

	elseif state == "end" then
		timer = timer + dt
	end
	
end

function love.draw()

	if state == "start" then
		lg.setColor(c.white)
		lg.draw(img.start)
		lg.setColor(c.black)
		lg.printf("Touch to play!",30,540,1220,"center")
	elseif state == "game" then
		lg.setColor(c.blue)
		lg.circle("fill",640, 360, 212*fat)
		lg.setColor(c.white)
		lg.draw(img.catdetails)
		lg.circle("fill",714,318,48*fat*1.6) -- right eye
		lg.circle("fill",564,326,42*fat*1.9)-- left eye
		lg.setColor(c.black)
		lg.circle("fill",718,326,22*fat*1.5) -- right pupil
		lg.circle("fill",563,320,18*fat*1.8) -- left pupil
		lg.printf(30 - math.floor(timer) .. " s",30,20,1220,"right") -- ui time
		lg.printf(math.floor(100*fat) .. "% fat",30,20,1220,"left") -- ui size
		
		-- draw food
		lg.setColor(c.white)
		for i,u in ipairs(food) do
			lg.draw(img.food,u.x-32,u.y-32,u.rot+timer/math.pi,1,1,32,32)
		--love.graphics.print(u.next,u.x, u.y)
		--love.graphics.circle("fill",u.x,u.y,20)
		end
	elseif state == "end" then
		lg.setColor(c.white)
		if timer%.25 > 0.125 then
			lg.draw(img.end1,0,0)
		else
			lg.draw(img.end2,0,0)
		end
		lg.setColor(c.black)
		if not win then
			lg.printf("Oh no! Fat cat asploded after " .. endtime .. "s!\n\nTouch to restart!",30,340,1220,"center") -- ui time
		else
			lg.printf("Yay! Fat cat is "..math.floor(100*fat).."% fat but survived!!!\n\nTouch to restart!",30,340,1220,"center") -- ui time
		end
	end

end

function love.mousepressed(x,y)

	if state == "start" then
		state = "game"
	elseif state == "game" then
	
  -- collisions
	for i,u in ipairs(food) do
		if dist(u,{x=x,y=y}) < 64 then
			u.del = true
			rand = math.random(1,3)
			aud.plop[rand]:stop()
			aud.plop[rand]:play()
		end
	end
	elseif state == "end" and timer > 2 then
		state = "start"
		aud.bg:play()
		timer = 0
		fat = 1
		food={}
		win=false
	end
	
end

function nvec(inpos)

  norm = math.sqrt(inpos.x^2 + inpos.y^2)
  out = { x = inpos.x / norm,
          y = inpos.y / norm }
  return out.x, out.y

end

function dist( in1, in2 )

  distX = in1.x - in2.x
  distY = in1.y - in2.y

  return( math.sqrt( distX^2 + distY^2 ) )

end